	;
	; LOCS 
	;
	; by Oscar Toledo G.
	; (c) Copyright 1988 Oscar Toledo G.
	;
	; Creation date: Sep/09/1988. I was age 9.
	;

L0100:	EQU $0100	; Setup VDP address
L0169:	EQU $0169	; Copy data into VRAM.
L04CC:	EQU $04CC	; Clear the screen.
L04F5:	EQU $04F5	; Read keyboard.

VDP:    EQU $01

START:
	LD SP,L87F0
	CALL L8114
	CALL L0100
	CALL L0169
	DB "LOCS OTEK",0
	DB 0,0,0
    IF 0
	LD HL,$3C40
	CALL L0100
	CALL L0169
	DB "32 BYTES",0
    ELSE
	DB 0,0,0
	DB 0,0,0
	DB 0,0,0,0
	DB 0,0,0,0
	DB 0
    ENDIF
L8028:	CALL L81C1
	CALL L807F
	CALL L0169
	DB "GRAFICO",0
	LD HL,$3EE1
	CALL L8063
	LD A,$3E
        OUT (VDP),A
	LD (L86F2),HL
	LD DE,L8700
L8049:	CALL L04F5
	LD (DE),A
	INC DE
	LD HL,(L86F2)
	PUSH AF
	CALL L0100
	POP AF
        OUT (VDP),A
	INC HL
	LD (L86F2),HL
	CP $0D
	JR Z,L8068
	JP L8049

L8063:	CALL L0100
	INC HL
	RET

L8068:	LD A,(L8700)
	CP $42
	JR NZ,L808F
	CALL L04CC
	JP L8028

L8075:	LD HL,$3D50
	LD (L86F0),HL
	CALL L04CC
	RET

L807F:	PUSH HL
	LD HL,(L86F0)
	CALL L0100
	LD A,$2A
        OUT (VDP),A
	POP HL
	CALL L0100
	RET

L808F:	CP $54
	JR NZ,L80BF
	LD HL,(L86F0)
	CALL L0100
	LD A,$20
        OUT (VDP),A
	LD HL,$3D50
	LD (L86F0),HL
	CALL L0100
	LD A,$2A
	OUT (VDP),A
	CALL L80B0
	JP L8028

L80B0:	LD HL,$3EC1
L80B3:	CALL L0100
	LD B,$40
L80B8:	LD A,$20
        OUT (VDP),A
	DJNZ L80B8
	RET

L80BF:	CP $53
	JR NZ,L80E6
	LD A,(L8700+3)
	SUB $30
	LD B,A
L80C9:	LD HL,(L86F0)
	CALL L0100
	LD A,$23
        OUT (VDP),A
	LD DE,$0020
	SBC HL,DE
	LD (L86F0),HL
	DJNZ L80C9
	CALL L80B0
	CALL L807F
	JP L8028

L80E6:	CP $44
	JR NZ,L811B
	LD A,(L8700+3)
	SUB $30
	LD B,A
L80F0:	LD HL,(L86F0)
	CALL L0100
	LD A,$23
        OUT (VDP),A
	LD DE,$0001
	ADD HL,DE
	NOP
	LD (L86F0),HL
	DJNZ L80F0
	CALL L80B0
	CALL L807F
	JP L8028

	DB $FF,$FF,$FF
	DB $FF,$FF,$FF,$FF

L8114:	CALL L8075
	LD HL,$3C01
	RET

L811B:	CP $41
	JR NZ,L8142
	LD A,(L8700+3)
	SUB $30
	LD B,A
L8125:	LD HL,(L86F0)
	CALL L0100
	LD A,$23
        OUT (VDP),A
	LD DE,$0020
	ADD HL,DE
	NOP
	LD (L86F0),HL
	DJNZ L8125
	CALL L80B0
	CALL L807F
	JP L8028

L8142:	CP $49
	JR NZ,L8169
	LD A,(L8700+3)
	SUB $30
	LD B,A
L814C:	LD HL,(L86F0)
	CALL L0100
	LD A,$23
        OUT (VDP),A
	LD DE,$0001
	SBC HL,DE
	LD (L86F0),HL
	DJNZ L814C
	CALL L80B0
	CALL L807F
	JP L8028

L8169:	CP $50
	JR NZ,L8194-1
	LD HL,$3EE5
	LD (L87F0),HL
	RST $10
	LD D,H
	LD E,L
	LD HL,(L86F0)
	CALL L0100
	LD A,$20
        OUT (VDP),A
	LD HL,$3C00
	ADD HL,DE
	LD (L86F0),HL
	CALL L0100
	LD A,$2A
        OUT (VDP),A
	CALL L80B0
	JP L8028

L8194:	LD HL,$3C01
	CALL L0100
	CALL L0169
	DB "* ERROR *",0
	LD B,$05
L81A9:	PUSH BC
	LD BC,$0000
L81AD:	DEC BC
	LD A,B
	OR C
	JR NZ,L81AD
	POP BC
	DJNZ L81A9
	LD HL,$3C00
	CALL L80B3
	CALL L80B0
	JP L8028

L81C1:	LD HL,$2118
	CALL L0100
	LD B,$08
L81C9:	LD A,$FF
        OUT (VDP),A
	DJNZ L81C9
L81CF:	LD HL,$2918
	CALL L0100
	LD B,$08
L81D7:	LD A,$FF
        OUT (VDP),A
	DJNZ L81D7
	LD HL,$3118
	CALL L0100
	LD B,$08
L81E5:	LD A,$FF
        OUT (VDP),A
	DJNZ L81E5
	LD HL,$3EC1
	RET
	
L86F0:	EQU $86F0
L86F2:	EQU $86F2
L8700:	EQU $8700
L87F0:	EQU $87F0
